package betterwithmods.common.world.gen.village;

import betterwithmods.common.BWMBlocks;
import net.minecraft.block.BlockStairs;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;

import java.util.List;
import java.util.Random;

/**
 * Created by tyler on 5/25/17.
 */
public class Library extends AbandonedVillagePiece {
    public Library() {
    }

    public Library(StructureVillagePieces.Start start, int type, Random rand, StructureBoundingBox p_i45571_4_, EnumFacing facing) {
        super(start, type);
        this.func_186164_a(facing);
        this.field_74887_e = p_i45571_4_;
    }

    /**
     * second Part of Structure generating, this for example places Spiderwebs, Mob Spawners, it closes
     * Mineshafts at the end, it adds Fences...
     */
    public boolean func_74875_a(World worldIn, Random randomIn, StructureBoundingBox structureBoundingBoxIn)
    {
        if (this.field_143015_k < 0)
        {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);

            if (this.field_143015_k < 0)
            {
                return true;
            }

            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 9 - 1, 0);
        }
        IBlockState table = this.func_175847_a(BWMBlocks.WOOD_TABLE.func_176223_P());
        IBlockState window = Blocks.field_150350_a.func_176223_P();
        IBlockState iblockstate = this.func_175847_a(Blocks.field_150347_e.func_176223_P());
        IBlockState iblockstate1 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        IBlockState iblockstate2 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.SOUTH));
        IBlockState iblockstate3 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.EAST));
        IBlockState iblockstate4 = this.func_175847_a(Blocks.field_150344_f.func_176223_P());
        IBlockState iblockstate5 = this.func_175847_a(Blocks.field_150446_ar.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 1, 7, 5, 4, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 8, 0, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 5, 0, 8, 5, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 6, 1, 8, 6, 4, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 7, 2, 8, 7, 3, iblockstate, iblockstate, false);

        for (int i = -1; i <= 2; ++i)
        {
            for (int j = 0; j <= 8; ++j)
            {
                this.func_175811_a(worldIn, iblockstate1, j, 6 + i, i, structureBoundingBoxIn);
                this.func_175811_a(worldIn, iblockstate2, j, 6 + i, 5 - i, structureBoundingBoxIn);
            }
        }

        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 0, 0, 1, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 5, 8, 1, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 1, 0, 8, 1, 4, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 1, 0, 7, 1, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 2, 0, 0, 4, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 2, 5, 0, 4, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 2, 5, 8, 4, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 2, 0, 8, 4, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 2, 1, 0, 4, 4, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 5, 7, 4, 5, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 2, 1, 8, 4, 4, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 0, 7, 4, 0, iblockstate4, iblockstate4, false);
        this.func_175811_a(worldIn, window, 4, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 5, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 6, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 4, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 5, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 6, 3, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 0, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 0, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 0, 3, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 0, 3, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 8, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 8, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 8, 3, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 8, 3, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 2, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 3, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 5, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, window, 6, 2, 5, structureBoundingBoxIn);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 4, 1, 7, 4, 1, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 4, 4, 7, 4, 4, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 3, 4, 7, 3, 4, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175811_a(worldIn, iblockstate4, 7, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate3, 7, 1, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 6, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 5, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 4, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate1, 3, 1, 4, structureBoundingBoxIn);

//        this.setBlockState(worldIn, Blocks.WOODEN_PRESSURE_PLATE.getDefaultState(), 6, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, table, 6, 1, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, table, 4, 1, 3, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.WOODEN_PRESSURE_PLATE.getDefaultState(), 4, 2, 3, structureBoundingBoxIn);
//        this.setBlockState(worldIn, Blocks.CRAFTING_TABLE.getDefaultState(), 7, 1, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 1, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 1, 2, 0, structureBoundingBoxIn);
//        this.createVillageDoor(worldIn, structureBoundingBoxIn, randomIn, 1, 1, 0, EnumFacing.NORTH);

        if (this.func_175807_a(worldIn, 1, 0, -1, structureBoundingBoxIn).func_185904_a() == Material.field_151579_a && this.func_175807_a(worldIn, 1, -1, -1, structureBoundingBoxIn).func_185904_a() != Material.field_151579_a)
        {
            this.func_175811_a(worldIn, iblockstate5, 1, 0, -1, structureBoundingBoxIn);

            if (this.func_175807_a(worldIn, 1, -1, -1, structureBoundingBoxIn).func_177230_c() == Blocks.field_185774_da)
            {
                this.func_175811_a(worldIn, Blocks.field_150349_c.func_176223_P(), 1, -1, -1, structureBoundingBoxIn);
            }
        }

        for (int l = 0; l < 6; ++l)
        {
            for (int k = 0; k < 9; ++k)
            {
                this.func_74871_b(worldIn, k, 9, l, structureBoundingBoxIn);
                this.func_175808_b(worldIn, iblockstate, k, -1, l, structureBoundingBoxIn);
            }
        }

        this.func_74893_a(worldIn, structureBoundingBoxIn, 2, 1, 2, 1);
        return true;
    }

    protected int func_180779_c(int villagersSpawnedIn, int currentVillagerProfession) {
        return 1;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(Library.class, 20, MathHelper.func_76136_a(random, 0 + size, 2 + size));
    }

    @Override
    public Class<?> getComponentClass() {
        return Library.class;
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 9, 9, 6, facing);
        return func_74895_a(structureboundingbox) && StructureComponent.func_74883_a(pieces, structureboundingbox) == null ? new Library(startPiece, p5, random, structureboundingbox, facing) : null;
    }
}
